#if !defined VIEWS_H
#define VIEWS_H

#include "controls.h"
#include "canvas.h"

class Fft;
class SampleIter;

class ViewFreq: public SimpleControl
{
public:
    ViewFreq (HWND hwndParent, int id) 
        : SimpleControl (hwndParent, id),
          _xRecord(0) {}
    void Update (Fft const & fftTransformer);
    void Clear ();
    void Fake ();
private:
    int         _xRecord;
};

class ViewWave: public SimpleControl
{
public:
    ViewWave (HWND hwndParent, int id, int cSamples) 
        : SimpleControl (hwndParent, id),
          _poly (cSamples),
          _penGreen (RGB(0, 255, 128))
    {}
    void Update (Fft const & fftTransformer);
private:
    PolyLine    _poly;
    Pen         _penGreen;
};

#endif